Subject: Re: [RFC PATCH 00/11] an introduction of library operating system for Linux (LibOS)

From: Hajime Tazaki<[email-masked]>
Date: Fri, 27 Mar 2015 01:24:34 +0900

Hi Richard,

At Wed, 25 Mar 2015 23:50:23 +0100,
Richard Weinberger wrote:
> 
> Hi!
> 
> Am 25.03.2015 um 15:48 schrieb Hajime Tazaki:
> > 
> > At Tue, 24 Mar 2015 16:27:51 +0100,
> > Richard Weinberger wrote:
> >>
> >> I'd say you should try hard to re-use/integrate your work in arch/um.
> >> With um we already have an architecture which targets userspace,
> >> having two needs a very good justification.
> > 
> > in addition to the case of my previous email, libos is not
> > limited to run on user-mode: it is just a library which can
> > be used with various programs. thus it has a potential (not
> > implemented yet) to run on a hypervisor like OSv or MirageOS
> > does for application containment, or run on a bare-metal
> > machine as rumpkernel does. We already have a clear
> > interface for the underlying layer to be able to add such
> > backend.
> > 
> > again, it's not only for user-mode.
> > 
> > mixing all the stuff in a single architecture may not only
> > mislead to users, but also introduce conceptual-disagreements
> > during code sharing of essential parts. 
> > 
> > I don't see any benefits to have a name 'um' with this idea.
> > 
> > # I'm not saying sharing a part of code is bad idea at all, btw.
> 
> After digging into the source I know what you mean and I have the

thank you for your deep review on the source code !

> feeling that "lib" is the wrong name.
> It has not much do to with an architecture.

could you care to elaborate your feeling more explicitly ?

what is an architecture here and what is _not_ an
architecture ? 
is UML an architecture in your sense (probably yes, but why)?

and what is arch/lib missing for an architecture ?

> Apart from that, I really like your idea!

great to hear that ;)

> You don't implement an architecture, you take some part of Linux
> (the networking stack) and create stubs around it to make it work.
> That means that we'd also have to duplicate kernel functions into
> arch/lib to keep it running.

again, the above same questions.

it (arch/lib) is a hardware-independent architecture which
provides necessary features to the remainder of kernel code,
isn't it ?

answers to those questions are really helpful for a feedback
on this RFC patches.

> BTW: It does not build here:
> ---cut---
>   LIB           liblinux-4.0.0-rc5.so

fixed, thanks: though the issue was in the external code
base (i.e., linux-libos-tools). there was a parallel build
(make -jX) problem.

# you may need to git pull at arch/lib/tools to reflect the updates.

thanks.

-- Hajime

--
To unsubscribe, send a message with 'unsubscribe linux-mm' in
the body to [email-masked].  For more info on Linux MM,
see: http://www.linux-mm.org/ .
Don't email: <a href=mailto:"[email-masked]"> [email-masked] </a>